#include <stdio.h>
#include <math.h>

int main (void)
{
int i;
int b, bestb;
double v, minv;
int f, bestf,low,high;
double realfreq, adlibfreq;
FILE *file;

file = stdout;
for (i = 0; i < 4096; i++)
	{
	minv = 10000; bestb = 0; bestf = 0;
	if (i == 0) realfreq = 0;
	else realfreq = 3580000.0 / (8*i) /2;
	for (b = 0; b < 8; b++)
		{
		f = floor (realfreq / (50000.0 * pow(2,b-20)) + 0.5);
		if (f > 1023)
			continue;
		adlibfreq = 50000.0 * f * pow(2,b-20);
		v = fabs(realfreq - adlibfreq);
		if (v < minv)
			{
			minv = v;
			bestb = b;
			bestf = f;
			}
		}

	low = bestf & 0xFF;
	high = (bestf >> 8)+(bestb << 2)+32;

	fprintf(file,"    db %4d,%4d ; %8.2f\n",low,high,realfreq);

/*	fprintf(file,"dw  %1d, %4d     ; %8.2f %8.2f\n",
								bestb, bestf, minv,realfreq);*/
	}

	return 0;
}
