;
;       Test program
;
.org    0
        ld      a,2
        out     (0FEh),a
        ld      ix,4000h
        im      1
        ei
        jp      start

.org    38h
        push    af
        push    hl
        inc     (ix+0)
        inc     ix
        push    ix
        pop     hl
        ld      a,l
        cp      32
        jr      nz,NoReset
        ld      ix,4000h
NoReset:
        ei
        pop     hl
        pop     af
        reti

start:  ld      hl,5800h
        ld      de,32*24
loop1:  ld      (hl),15
        inc     hl
        dec     de
        ld      a,d
        or      e
        jr      nz,loop1

        ld      hl,5A00h
loop3:  ld      (hl),l
        inc     l
        jr      nz,loop3

        ld      hl,4000h
        ld      de,32*192
loop2:  ld      (hl),0F8h
        bit     2,h
        jr      z,loop4
        ld      (hl),07h

loop4:  inc     hl
        dec     de
        ld      a,d
        or      e
        jr      nz,loop2

main:
        ld      a,0FEh
        in      a,(0FEh)
        ld      hl,5800h+256
        call    OutPattern

        ld      a,0FDh
        in      a,(0FEh)
        call    OutPattern

        ld      a,0FBh
        in      a,(0FEh)
        call    OutPattern

        ld      a,0F7h
        in      a,(0FEh)
        call    OutPattern

        ld      a,0EFh
        in      a,(0FEh)
        call    OutPattern

        ld      a,0DFh
        in      a,(0FEh)
        call    OutPattern

        ld      a,0BFh
        in      a,(0FEh)
        call    OutPattern

        ld      a,07Fh
        in      a,(0FEh)
        call    OutPattern

        halt
        jp      main

OutPattern:
        push    af
        push    hl
        ld      b,8
OPLoop:
        ld      (hl),0
        bit     7,a
        jr      z,OPSkip
        ld      (hl),76h
OPSkip: inc     hl
        add     a,a
        djnz    OPLoop
        ld      de,32
        pop     hl
        pop     af
        add     hl,de
        ret

.org    16384
.end
